<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/distortmesh.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>distortmesh.c</h1><a href="distortmesh_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: distortmesh.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="init_8h.html#a07f75fef1770fdca0f1cf8ea3369c8b2">00029</a> <span class="keywordtype">int</span> <a class="code" href="distortmesh_8c.html#a07f75fef1770fdca0f1cf8ea3369c8b2">DistortMesh</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   PetscTruth   flg;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordtype">int</span> rank,size;
<a name="l00036"></a>00036   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00037"></a>00037   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keywordflow">if</span> (rank) {
<a name="l00040"></a>00040     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00041"></a>00041   }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="comment">/* scale mesh */</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   PetscReal mesh_scale[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00046"></a>00046   <span class="keywordtype">int</span> nmax;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00049"></a>00049   ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-mesh_scale&quot;</span>,mesh_scale,&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00051"></a>00051     <span class="comment">/* set default values if option is missing */</span>
<a name="l00052"></a>00052     mesh_scale[0]=mesh_scale[1]=mesh_scale[2]=1.0;
<a name="l00053"></a>00053     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option -mesh_scale not found or incorrect number of values given.\nUsing default value &#39;%g,%g,%g&#39;!\n&quot;</span>,
<a name="l00054"></a>00054       mesh_scale[0],mesh_scale[1],mesh_scale[2]
<a name="l00055"></a>00055     );
<a name="l00056"></a>00056   }
<a name="l00057"></a>00057   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>) {
<a name="l00058"></a>00058     <span class="comment">/* set default values if option is missing */</span>
<a name="l00059"></a>00059     SETERRQ1(PETSC_ERR_ARG_CORRUPT,
<a name="l00060"></a>00060       <span class="stringliteral">&quot;Option -mesh_scale has incorrect number of values: %i!\n&quot;</span>,
<a name="l00061"></a>00061       nmax
<a name="l00062"></a>00062     );
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064   <span class="keywordflow">else</span> {
<a name="l00065"></a>00065     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Scaling mesh: &#39;%g,%g,%g&#39;!\n&quot;</span>,
<a name="l00066"></a>00066       mesh_scale[0],mesh_scale[1],mesh_scale[2]
<a name="l00067"></a>00067     );
<a name="l00068"></a>00068     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00069"></a>00069       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; j++) {
<a name="l00070"></a>00070         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+j] *= mesh_scale[j];
<a name="l00071"></a>00071       }
<a name="l00072"></a>00072     }
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">/* shift mesh */</span>
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   PetscReal shift[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00079"></a>00079   nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00080"></a>00080   ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-shift&quot;</span>,shift,&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00081"></a>00081   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00082"></a>00082     <span class="comment">/* set default values if option is missing */</span>
<a name="l00083"></a>00083     shift[0]=shift[1]=shift[2]=0;
<a name="l00084"></a>00084     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option -shift not found, using default value &#39;%g,%g,%g&#39;!\n&quot;</span>,
<a name="l00085"></a>00085       shift[0],shift[1],shift[2]
<a name="l00086"></a>00086     );
<a name="l00087"></a>00087   }
<a name="l00088"></a>00088   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>) {
<a name="l00089"></a>00089     <span class="comment">/* set default values if option is missing */</span>
<a name="l00090"></a>00090     SETERRQ1(PETSC_ERR_ARG_CORRUPT,
<a name="l00091"></a>00091       <span class="stringliteral">&quot;Option -shift has incorrect number of values: %i!\n&quot;</span>,
<a name="l00092"></a>00092       nmax
<a name="l00093"></a>00093     );
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095   <span class="keywordflow">else</span> {
<a name="l00096"></a>00096     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Shifting mesh: &#39;%g,%g,%g&#39;!\n&quot;</span>,
<a name="l00097"></a>00097       shift[0],shift[1],shift[2]
<a name="l00098"></a>00098     );
<a name="l00099"></a>00099     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00100"></a>00100       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; j++) {
<a name="l00101"></a>00101         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+j] += shift[j];
<a name="l00102"></a>00102       }
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">/* distort the mesh */</span>
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keywordtype">int</span> meshdist;
<a name="l00110"></a>00110   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-meshdist&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;meshdist,&amp;flg);CHKERRQ(ierr);
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00112"></a>00112     <span class="comment">/* set default values if option is missing */</span>
<a name="l00113"></a>00113     meshdist=0;
<a name="l00114"></a>00114     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00115"></a>00115       <span class="stringliteral">&quot;Option -meshdist not found, using default value %i!\n&quot;</span>,
<a name="l00116"></a>00116       meshdist
<a name="l00117"></a>00117     );
<a name="l00118"></a>00118   }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;meshdist: %i\n&quot;</span>,meshdist);
<a name="l00121"></a>00121   <span class="keywordflow">if</span> (meshdist==0) {
<a name="l00122"></a>00122     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;mesh undistorted\n&quot;</span>);
<a name="l00123"></a>00123     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00124"></a>00124   }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   PetscReal distpar;
<a name="l00127"></a>00127   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-distpar&quot;</span>,&amp;distpar,&amp;flg);CHKERRQ(ierr);
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00129"></a>00129     <span class="comment">/* set default values if option is missing */</span>
<a name="l00130"></a>00130     distpar=0;
<a name="l00131"></a>00131     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00132"></a>00132       <span class="stringliteral">&quot;Option -distpar not found, using default value %g!\n&quot;</span>,
<a name="l00133"></a>00133       distpar
<a name="l00134"></a>00134     );
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">/* elevertvol will check if the mesh is corrupted</span>
<a name="l00138"></a>00138 <span class="comment">     i.e. overlapping elements = negative volumes of tetrahedra</span>
<a name="l00139"></a>00139 <span class="comment">  */</span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   PetscReal elenmax,elenmin;
<a name="l00142"></a>00142   elenmax=0.0;
<a name="l00143"></a>00143   elenmin=1.0/<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00146"></a>00146     <span class="comment">/* Get Vertex coordinates */</span>
<a name="l00147"></a>00147     <span class="keywordtype">int</span> *t_v;
<a name="l00148"></a>00148     t_v=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150     PetscReal *x1,*x2,*x3,*x4;
<a name="l00151"></a>00151     x1=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[0]*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00152"></a>00152     x2=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[1]*ND;
<a name="l00153"></a>00153     x3=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[2]*ND;
<a name="l00154"></a>00154     x4=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+t_v[3]*ND;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="comment">/* Calculate edge lengths */</span>
<a name="l00157"></a>00157     PetscReal edge[ND];
<a name="l00158"></a>00158     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x1,1,edge,1);
<a name="l00159"></a>00159     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x2,1,edge,1);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     PetscReal elen;
<a name="l00162"></a>00162     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00163"></a>00163     elenmax=PetscMax(elenmax,elen);
<a name="l00164"></a>00164     elenmin=PetscMin(elenmin,elen);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x1,1,edge,1);
<a name="l00167"></a>00167     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x3,1,edge,1);
<a name="l00168"></a>00168     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00169"></a>00169     elenmax=PetscMax(elenmax,elen);
<a name="l00170"></a>00170     elenmin=PetscMin(elenmin,elen);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x1,1,edge,1);
<a name="l00173"></a>00173     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x4,1,edge,1);
<a name="l00174"></a>00174     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00175"></a>00175     elenmax=PetscMax(elenmax,elen);
<a name="l00176"></a>00176     elenmin=PetscMin(elenmin,elen);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x2,1,edge,1);
<a name="l00179"></a>00179     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x3,1,edge,1);
<a name="l00180"></a>00180     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00181"></a>00181     elenmax=PetscMax(elenmax,elen);
<a name="l00182"></a>00182     elenmin=PetscMin(elenmin,elen);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x2,1,edge,1);
<a name="l00185"></a>00185     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x4,1,edge,1);
<a name="l00186"></a>00186     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00187"></a>00187     elenmax=PetscMax(elenmax,elen);
<a name="l00188"></a>00188     elenmin=PetscMin(elenmin,elen);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(ND,x3,1,edge,1);
<a name="l00191"></a>00191     <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(ND,-1.0,x4,1,edge,1);
<a name="l00192"></a>00192     elen=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(ND,edge,1);
<a name="l00193"></a>00193     elenmax=PetscMax(elenmax,elen);
<a name="l00194"></a>00194     elenmin=PetscMin(elenmin,elen);
<a name="l00195"></a>00195   }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;distorting mesh - meshdist: %i distpar: %g elenmin: %g\n&quot;</span>,
<a name="l00198"></a>00198     meshdist,distpar,elenmin
<a name="l00199"></a>00199   );
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   PetscRandom rctx;
<a name="l00202"></a>00202   ierr = PetscRandomCreate(PETSC_COMM_WORLD,&amp;rctx);CHKERRQ(ierr);
<a name="l00203"></a>00203   ierr = PetscRandomSetFromOptions(rctx);CHKERRQ(ierr);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00206"></a>00206     PetscReal randist[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00207"></a>00207     PetscReal norm;
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     <span class="comment">/* calculate random vector for M, which lies within</span>
<a name="l00210"></a>00210 <span class="comment">       the |M|=1 sphere, to guarantee uniform distribution</span>
<a name="l00211"></a>00211 <span class="comment">       on the unit sphere</span>
<a name="l00212"></a>00212 <span class="comment">    */</span>
<a name="l00213"></a>00213     <span class="keywordflow">do</span> {
<a name="l00214"></a>00214       PetscRandomGetValue(rctx,&amp;randist[0]); randist[0] = randist[0]*2.0-1.0;
<a name="l00215"></a>00215       PetscRandomGetValue(rctx,&amp;randist[1]); randist[1] = randist[1]*2.0-1.0;
<a name="l00216"></a>00216       PetscRandomGetValue(rctx,&amp;randist[2]); randist[2] = randist[2]*2.0-1.0;
<a name="l00217"></a>00217     } <span class="keywordflow">while</span> ((norm=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,randist,1)) &gt; 1.0);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219     <span class="keywordflow">switch</span> (meshdist) {
<a name="l00220"></a>00220       <span class="keywordflow">case</span> 1: <span class="comment">/* distort only interior mesh */</span>
<a name="l00221"></a>00221         <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]] == <a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">C_INT</a>) {
<a name="l00222"></a>00222           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0] += randist[0]/norm*distpar*elenmin;
<a name="l00223"></a>00223           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1] += randist[1]/norm*distpar*elenmin;
<a name="l00224"></a>00224           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2] += randist[2]/norm*distpar*elenmin;
<a name="l00225"></a>00225         }
<a name="l00226"></a>00226       <span class="keywordflow">break</span>;
<a name="l00227"></a>00227       <span class="keywordflow">case</span> 2: <span class="comment">/* distort only boundary mesh */</span>
<a name="l00228"></a>00228         <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]] &gt;= 0) {
<a name="l00229"></a>00229           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0] += randist[0]/norm*distpar*elenmin;
<a name="l00230"></a>00230           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1] += randist[1]/norm*distpar*elenmin;
<a name="l00231"></a>00231           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2] += randist[2]/norm*distpar*elenmin;
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233       <span class="keywordflow">break</span>;
<a name="l00234"></a>00234       <span class="keywordflow">case</span> 3: <span class="comment">/* distort whole mesh */</span>
<a name="l00235"></a>00235         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0] += randist[0]/norm*distpar*elenmin;
<a name="l00236"></a>00236         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1] += randist[1]/norm*distpar*elenmin;
<a name="l00237"></a>00237         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2] += randist[2]/norm*distpar*elenmin;
<a name="l00238"></a>00238       <span class="keywordflow">break</span>;
<a name="l00239"></a>00239     }
<a name="l00240"></a>00240   }
<a name="l00241"></a>00241   ierr = PetscRandomDestroy(rctx);CHKERRQ(ierr);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

